/**
 * 
 */
package net.smartlab.web.auth;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.smartlab.web.AbstractArchiveAction;
import net.smartlab.web.ActionException;
import net.smartlab.web.BusinessException;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

/**
 * @author svetrini
 * @author rlogiacco
 */
public abstract class SubjectAction extends AbstractArchiveAction {

	/**
	 * @uml.property name="domain"
	 * @uml.associationEnd multiplicity="(1 1)"
	 */
	protected Domain domain = Domain.getInstance();


	/**
	 * @param form
	 * @param request
	 * @param response
	 * @param mapping
	 * @return
	 * @throws ActionException
	 * @throws BusinessException
	 */
	public String permissions(ActionForm form, HttpServletRequest request, HttpServletResponse response,
			ActionMapping mapping) throws ActionException, BusinessException {
		DynaActionForm dform = (DynaActionForm)form;
		String id = dform.getString("subject-id");
		if (id != null && !"".equals(id) && !"0".equals(id)) {
			Subject subject = domain.findSubject(id);
			request.setAttribute("subject", subject);
		}
		return "success";
	}

	public static Object[] selectedBOCollecction2IdArray(Collection selectedObjects) {
		ArrayList resultC = new ArrayList();
		Class[] parameters = {};
		Object[] args = {};
		for (Iterator iterator = selectedObjects.iterator(); iterator.hasNext();) {
			Object tmp = (Object)iterator.next();
			try {
				Method getId = tmp.getClass().getMethod("getId", parameters);
				Object id = getId.invoke(tmp, args);
				resultC.add("" + id);
			} catch (Exception e) {
				// NOP
			}
		}
		Object[] tmp = resultC.toArray();
		return tmp;
	}
}
